/*name bdreset.c*/

/*
This resets the SA85 Modbus Plus board
Syntax: BDRESET [/s] [/n]
where /s provides the s/w interrupt to use (default 0x5c)
where /n is the LAN adapter number to use (default #0)
Example:   BDRESET /s5c /n0
           Reset adapter #0, using s/w int 0x5c
is the Recommended s/w interrupt to use!

*/
#include <stdio.h>
#include <dos.h>
#include <process.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "netbios.h"
#include "netlib.h"

/*
variables
*/


/*
externals

*/

/*
prototypes
*/
int main(int argc, char *argv[]);
void syntax(void);

/*
main()

*/

int main(argc, argv)
int argc;
char *argv[];
    {
    int adaptno;

    if (argc == 1) {
        syntax();
        exit(0);
        }

	adaptno=atoi(argv[1]); /*set lan adapter # to use */

    if((adaptno!=0)&&(adaptno!=1)){
        fprintf(stderr, "\nMust be 0 or 1\n\n");
        syntax();
        exit(0);
        }

    ncb_reset(adaptno);
    printf("\nSA85 #%d reset.\n", adaptno);
    exit(0);

    return 0;
    }

void syntax()
    {
	fprintf(stderr, "\n** No action taken **");
	fprintf(stderr, "\nResets the chosen SA85 board");
    fprintf(stderr, "\nExample:   BDRESET 0    (first SA85)");
    fprintf(stderr, "\nExample:   BDRESET 1    (second SA85)");
    }
