/*
mbpcheck.c

This program checks to see if any modbus plus adapters are installed.
*/

/* include */
#include <stdio.h>
#include <netbios.h>
#include <netlib.h>

/* prototypes */
void main( void );

/* global vars. */
NCB n_c_b;                          /* allocate an NCB */
unsigned char mbuffer[ 256 ];       /* allocate buffer area for response */
int lan_number;
int peer_number;

/*
main

This code module checks to see if any modbus plus interfaces are present.
*/

void main() {
    /* CHECK FOR MODBUS PLUS ADAPTER 0 */
    n_c_b.NCB_BUFFER = &mbuffer[ 0 ];
    lan_number = 0;                 /* adapter number 0 */
    if( ncb_status( &n_c_b, lan_number ) != 0 ) {
        printf( "MODBUS PLUS Adapter %d board not found.\n", lan_number );
    }
    else {
        peer_number = ( int ) mbuffer[ 6 ];
        printf( "MODBUS PLUS Adapter %d identified as node %d.\n",
            lan_number, peer_number );
    }

    /* CHECK FOR MODBUS PLUS ADAPTER 1 */
    n_c_b.NCB_BUFFER = &mbuffer[ 0 ];
    lan_number = 1;                 /* adapter number 1 */
    if( ncb_status( &n_c_b, lan_number ) != 0 ) {
        printf( "MODBUS PLUS Adapter %d board not found.\n", lan_number );
    }
    else {
        peer_number = ( int ) mbuffer[ 6 ];
        printf( "MODBUS PLUS Adapter %d identified as node %d.\n",
            lan_number, peer_number );
    }
}

