#define INCL_SUB
#include <os2.h>

#include <stdio.h>
#include <dos.h>
#include <time.h>
#include <process.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <conio.h>
#include "netbios.h"
#include "netlib.h"
#include "testslav.h"

/*
prototypes
*/
int main(int argc, char *argv[]);
int allocate_paths(unsigned char address);

int fslave6(unsigned int tblbuff[], unsigned char cmdbuff[], 
            unsigned char repbuff[], unsigned int dbuff[]);

extern int hi(unsigned int arg);
extern int lo(unsigned int arg);
extern int send_exc_response(int code, unsigned char *cmdbuff, unsigned char *repbuff);
extern int fslave(unsigned int *tblbuff, unsigned char *cmdbuff, unsigned char *repbuff, unsigned int *dbuff);
extern int decode_modbus_msg(unsigned char *cmdbuff, unsigned char *repbuff, unsigned int *dbuff);
extern int slave_read_0x(void);
extern int slave_read_1x(void);
extern int slave_read_4x(unsigned char *cmdbuff, unsigned char *repbuff, unsigned int *dbuff);
extern int slave_read_3x(void);
extern int slave_force_0x(void);
extern int slave_preset_4x(unsigned char *cmdbuff, unsigned char *repbuff);
extern int slave_read_exc_status(void);
extern int slave_loopback(void);
extern int slave_force_0x_blk(void);
extern int slave_preset_4x_blk(unsigned char *cmdbuff, unsigned char *repbuff);
extern int slave_slave_id(void);
extern int slave_wcmd(int nbytes, unsigned char *cmdbuff);
extern int slave_rrep(int *n_bytes, unsigned char *repbuff);
extern int back_dbread(int offset, unsigned far *buffer, int quantity);
extern int back_dbwrite(int offset, unsigned far *buffer, int quantity);

#ifdef InstantC
unsigned int this_database[100];
#else
unsigned int this_database[10000];
#endif
NCB *data_ncbp, dummyncb;
unsigned char mbuffer[ 256 ];

#define LENGTH 81       /* length of string buffer */
#define HANDLE 0        /* vio handle always 0 */

struct dxparamst DMA_area;
unsigned int *T = (unsigned int *) &DMA_area.table[0];
unsigned char cmdbuff[524], repbuff[524];
unsigned int dbuff[256];

/*
 * DEBUG enables very nice debugging displays, if defined
 */
/* #define DEBUG   1 */

int main(argc, argv)
int argc;
char *argv[];
    {
    char buffer[LENGTH];
    unsigned char attr = 0x70;  /* reverse video attribute */
    long count = 0L;
    unsigned Cell = 0x0720; /* for scrolling */
    char path[80];
    int node_adr, ret_val, slave_path, lan_number;

    VioScrollUp(0,0,-1,-1,-1,(char far *)&Cell,0); /* clear the screen */

    sprintf(buffer,"            << TESTSLAV >>                  ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 2, 3, &attr, HANDLE);
    sprintf(buffer,"AEG Modicon slave module for Modbus+ OS/2   ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 3, 3, &attr, HANDLE);

    switch (argc) {
	case 0:
	case 1:
		sprintf(buffer, "Usage is: A>TESTSLAV <slave path> <LAN adapter#>");
		VioWrtCharStrAtt(buffer, strlen(buffer), 8, 3, &attr, HANDLE);
		VioSetCurPos(9, 1, HANDLE);
		exit(1);
		break;
	case 2:
		lan_number = 0;	/* default */
		break;
	case 3:
		ret_val = sscanf(argv[2], "%d", &lan_number);
		if (lan_number != 0 && lan_number != 1) {
			sprintf(buffer, "LAN adapter # must be 0 or 1. ");
			VioWrtCharStrAtt(buffer, strlen(buffer), 8, 3, &attr, HANDLE);
			VioSetCurPos(9, 1, HANDLE);
			exit(1);
			}
		break;
	default:
		sprintf(buffer, "Usage is: A>TESTSLAV <slave path> <LAN adapter#>");
		VioWrtCharStrAtt(buffer, strlen(buffer), 8, 3, &attr, HANDLE);
		VioSetCurPos(9, 1, HANDLE);
		exit(1);
		break;
		}

	ret_val = sscanf(argv[1], "%d", &slave_path);
	if (ret_val != 1 || slave_path < 1 || slave_path > 8) {
		sprintf(buffer, "Slave path must be in the range 1 to 8. ");
		VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);
		VioSetCurPos(6, 1, HANDLE);
		exit(1);
		}


    dummyncb.NCB_BUFFER = &mbuffer[ 0 ];
    if( ncb_status( &dummyncb, lan_number) != 0 ) {
    sprintf(buffer,"MODBUS PLUS Adapter board %d not found.  ",lan_number);
    VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);
    }
    else {
        node_adr = ( int ) mbuffer[ 6 ];
        sprintf(buffer,"MODBUS PLUS Adapter %d identified as node %d.",lan_number,node_adr);
        VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);
    }

    sprintf(path,"DS.%d.0.0.0.0",slave_path);
    if ((data_ncbp = ncb_open(path, lan_number)) == NULL) {
        sprintf(buffer,"Unable to open DATA SLAVE path (internal).");
        VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);
        VioSetCurPos(6,1,HANDLE);
        exit(1);
        }

    for (;  ;) {
        /* loop repeatedly */

        T[0] = 6;       /* port "6" is SA85 Modbus Plus */
        T[1] = node_adr;        /* we're slave address #12 */
        T[2] = T[3] = 0;    /* don't use these, set them to zero */
        T[4] = 0;       /* doesn't matter */
        fslave6(T, cmdbuff, repbuff, dbuff);

        if (T[5] != 0)
            printf("Slave Status = 0x%X", T[5]);
        else {
            sprintf(buffer, "# of Slave requests serviced: %ld ", count++);
            VioWrtCharStrAtt(buffer, strlen(buffer), 5, 3, &attr, HANDLE);
            }
        if (kbhit()) {
            sprintf(buffer, "<< TESTSLAV TERMINATED NORMALLY >>");
            VioWrtCharStrAtt(buffer, strlen(buffer), 6, 3, &attr, HANDLE);
            getch();
            ncb_close(data_ncbp);  /*close the path*/
            VioSetCurPos(8,1,HANDLE);
            exit(0);
            }
        }
    return 0;
    }

static int swap(unsigned int *, int);
static int clength;     /* required only when #DEBUG defined */

int fslave6(tblbuff, cmdbuff, repbuff, dbuff)
unsigned int tblbuff[];
unsigned char repbuff[], cmdbuff[];
unsigned int dbuff[];
    {
/****************************************************************************
*  f_slave          
*  Simulate Modbus Slave
*  Calling this block will look for a Modbus message on the communications port.
*  If a good (supported) Modbus message, and we're the correct slave,
*       the approprate Modbus slave function will be called.
*  Current status will be returned in tblbuff[5].
*  Received Modbus function number will be returned in tblbuff[6].
*****************************************************************************/
/*    char error_text[80];   goes with decode_status - not needed here */

/* CALL block table of registers: register offsets                      */
/* tblbuff[0] PORT          0     Modbus slave port to use (1-6) on Co-Pro  */
/* tblbuff[1] SLAVE         1     USER: Slave # we'll pretend to be         */
/* tblbuff[2] ADDRESS       2     not used  (in master, USER: Slave data address) */
/* tblbuff[3] QUANTITY      3     not used  (in master, USER: quantity of regs in/out */
/* tblbuff[4] MODE          4     not used  (in master, USER: 0 = ASCII  1 = RTU mode(relaxed timing only)) */
/* tblbuff[5] M_STATUS      5     Modbus slave status word - statuses appear here */
/* tblbuff[6] DATA1         6     function number for Modbus message received */
/*            (all other data regs follow)                              */

    static int nbytes;  /* # bytes read from slave      */

    tblbuff[M_STATUS] = slave_rrep(&nbytes, repbuff);

/*              decode_status(reply_status, error_text); */
/* decode and report on reply_status */
/* not needed here, was used in MSDOS version - see MTERM.C Modbus Terminal Emulator */

    if (tblbuff[M_STATUS] == 0) {
        /* now decode the good Modbus message */

/* Only question is, decode_modbus_msg returns success or no success. */
/* How do we treat that status here ? */

        clength = nbytes;
        decode_modbus_msg(cmdbuff, repbuff, dbuff);
                          /* pass address, Co-Pro Port to use */
        tblbuff[DATA1] = repbuff[DATA1];    /* received Modbus function_no number is returned in tblbuff[1] */
        return DXDONE;
        }
    else 
/* This is one place we might want to CONSIDER issuing an exception response */
        return DXERROR; /* Bad Modbus message received */
    }

int decode_modbus_msg(cmdbuff, repbuff, dbuff)
unsigned char *repbuff, *cmdbuff;
unsigned int *dbuff;
    {                   /* decode_modbus_msg */
#ifdef DEBUG
    int i, length;
#endif

#ifdef DEBUG
    printf("** Good Modbus message received: ");
    printf("     ");
    length = clength;
    for (i = 0;  i < length;  i++) {
        if (repbuff[i] < 0x10)
            printf("0");    /* leading zero, if necessary */
        printf("%X", (unsigned int) repbuff[i]);
        }
    printf("");
    printf("     for address: 0x%X   function 0x%X ", repbuff[0], repbuff[1]);
#endif
/*************************************************************************/
    switch (repbuff[1]) {
/*************************************************************************/
    case 1:             /* Modbus code 01 - read output status */
#ifdef DEBUG
        printf("     ** Request for unimplemented function ** Modbus code 01 - read output status");
        printf("     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("     quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_read_0x(); */
        break;
/*************************************************************************/
    case 2:             /* Modbus code 02 - read input status */
#ifdef DEBUG
        printf("     ** Request for unimplemented function ** Modbus code 02 - read input status");
        printf("     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("     quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_read_1x(); */
        break;
/*************************************************************************/
    case 3:             /* Modbus code 03 - read output registers */
#ifdef DEBUG
        printf("     Modbus code 03 - read output registers");
        printf("     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("     quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
#endif
        return (slave_read_4x(cmdbuff, repbuff, dbuff));
        break;
/*************************************************************************/
    case 4:             /* Modbus code 04 - read input registers */
#ifdef DEBUG
        printf("     ** Request for unimplemented function ** Modbus code 04 - read input registers");
        printf("     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("     quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_read_3x(); */
        break;
/*************************************************************************/
    case 5:             /* Modbus code 05 - force a single coil */
#ifdef DEBUG
        printf("     ** Request for unimplemented function ** Modbus code 05 - force a single coil");
        printf("     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
#if 0
        if (repbuff[4] = 0xFF) {
#ifdef DEBUG
            printf( "     turn coil ON");
#endif
            slave_force_0x();
            }
        else {
#ifdef DEBUG
            printf( "     turn coil OFF");
#endif
            slave_force_0x();
            }
#endif
        break;
/*************************************************************************/
    case 6:             /* Modbus code 06 - preset single register */
#ifdef DEBUG
        printf("     Modbus code 06 - preset single register");
        printf("     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("     data(high): 0x%X   data(low) 0x%X ", repbuff[4], repbuff[5]);
#endif
        slave_preset_4x(cmdbuff, repbuff);
        break;
/*************************************************************************/
    case 7:             /* Modbus code 07 - read slave exception coils */
#ifdef DEBUG
        printf("     ** Request for unimplemented function ** Modbus code 07 - read slave exception coils");
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_read_exc_status(); */
        break;
/*************************************************************************/
    case 8:             /* Modbus code 08 - loop back test */
#ifdef DEBUG
        printf("     ** Request for unimplemented function ** Modbus code 08 - loop back test");
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_loopback(); */
        break;
/*************************************************************************/
    case 15:            /* Modbus code 15 - force multiple coils */
#ifdef DEBUG
        printf("     ** Request for unimplemented function ** Modbus code 15 - force multiple coils");
        printf("     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("     quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
        printf("     one eighth of quantity ??? : 0x%X", repbuff[6]);
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_force_0x_blk(); */
        break;
/*************************************************************************/
    case 16:            /* Modbus code 16 - preset multiple registers */
#ifdef DEBUG
        printf("     Modbus code 16 - preset multiple registers");
        printf("     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("     quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
        printf("     one half of quantity ??? : 0x%X", repbuff[6]);
#endif
        slave_preset_4x_blk(cmdbuff, repbuff);
        break;
/*************************************************************************/
    case 17:            /* Modbus code 17 - report slave id */
#ifdef DEBUG
        printf("     ** Request for unimplemented function ** Modbus code 17 - report slave id");
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_slave_id(); */
        break;
/*************************************************************************/
    default:
#ifdef DEBUG
        printf("     Unsupported Modbus Function Type");
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
        break;
        }
#ifdef DEBUG
    printf("");
#endif
    return SUCCESS;
    }                   /* decode_modbus_msg */


int slave_read_0x()
    {                   /* slave_read_0x */
    return SUCCESS;
    }                   /* slave_read_0x */

int slave_read_1x()
    {                   /* slave_read_1x */
    return SUCCESS;
    }                   /* slave_read_1x */

int slave_read_4x(cmdbuff, repbuff, dbuff)
   /* Function to handle request for holding registers */
unsigned char repbuff[], cmdbuff[];
unsigned int dbuff[];
    {                   /* slave_read_4x */
    static int i, j, offset, quantity;

#ifdef DEBUG
    printf("In slave_read_4x");
#endif

/*
 * We Received:        |    We will send:
 * ------------------------------------------------------
 * address             |    address
 * function            |    function
 * data start reg high |    byte count
 * data start reg low  |    data out reg high  40108
 * data # regs high    |    data out reg low   40108
 * data # regs low     |    data out reg high  40109
 *                     |    data out reg low   40109
 *                     |    etc
 */
    swap((unsigned int *) &repbuff[2], 2);  /* fixup address and quantity */
    offset = *(int *) &repbuff[2];
    quantity = *(int *) &repbuff[4];    /* quantity in 16-bit WORDS, not bytes */

/* validate quantity here. If greater than 125 registers, send back exception response */
    if (quantity > 125) {
        send_exc_response(3, cmdbuff, repbuff);
                        /* bad data */
        return FAILURE;
        }
    else {
#ifdef DEBUG
        printf("In slave_read_4x, offset=%X, qty=%X", offset, quantity);
#endif
        if (back_dbread(offset, dbuff, quantity) == 0) {
                        /* int offset, unsigned int *buffer, int qty */

#ifdef DEBUG
            printf("In slave_read_4x, good status from DBREAD");
#endif
            cmdbuff[0] = repbuff[0];
                        /* byte 1 is our slave # */
            cmdbuff[1] = repbuff[1];
                        /* byte 2 is function code */
            cmdbuff[2] = (unsigned char) quantity * 2;
                        /* byte 3 is byte count */

        /* Note: the qty field in the next line was for REGISTERS, so we have to multiply by 2 */
            for (i = 3,  j = 0;  i < (3 + (2 * quantity));  i += 2,  ++j) {
                cmdbuff[i] = (unsigned char) hi(dbuff[j]);
                cmdbuff[i + 1] = (unsigned char) lo(dbuff[j]);
                }
            slave_wcmd(i, cmdbuff);
                        /* transmit response */
            return SUCCESS;
            }
        else {
#ifdef DEBUG
            printf("In slave_read_4x, bad status from DBREAD");
#endif
/* Also, transmit back exception response here */
            send_exc_response(2, cmdbuff, repbuff);
                        /* bad address */
            return FAILURE;
            }
        }
    }                   /* slave_read_4x */

int slave_read_3x()
    {                   /* slave_read_3x */
    return SUCCESS;
    }                   /* slave_read_3x */

int slave_force_0x()
    {                   /* slave_force_0x */
    return SUCCESS;
    }                   /* slave_force_0x */

int slave_preset_4x(cmdbuff, repbuff)
   /* Function to handle request for setting a single holding register */
unsigned char repbuff[], cmdbuff[];
    {                   /* slave_preset_4x */
    static int offset;
    static unsigned int data;
    int broadcast;      /* if 1, broadcast mode, send no response */

#ifdef DEBUG
    printf("In slave_preset_4x");
#endif

/*
 * We Received:        |    We will send:
 * ------------------------------------------------------
 * address             |    address
 * function            |    function
 * data reg high       |    data reg high
 * data reg low        |    data reg low 
 * data value high     |    data value hight
 * data value low      |    data value low
 * (In this case response identical to what we received)
 */
    swap((unsigned int *) &repbuff[2], 2);  /* fixup address and data */
    broadcast = !repbuff[0];    /* if broadcast mode, address is 0 */
    offset = *(int *) &repbuff[2];
    data = *(int *) &repbuff[4];

#ifdef DEBUG
    printf("In slave_preset_4x, offset=%X, data=%X", offset, data);
#endif
    if (back_dbwrite(offset, &data, 1) == 0) {
                        /* int offset, unsigned int *buffer, int qty */
#ifdef DEBUG
        printf("In slave_preset_4x, good status from DBWRITE");
#endif
        if (!broadcast) {
                        /* If not Broadcast mode, issue response */
            cmdbuff[0] = repbuff[0];
                        /* byte 1 is our slave # */
            cmdbuff[1] = repbuff[1];
                        /* byte 2 is function code */
            cmdbuff[2] = (unsigned char) hi(offset);
                        /* byte 3 is offset (ho) */
            cmdbuff[3] = (unsigned char) lo(offset);
                        /* byte 4 is offset (lo) */
            cmdbuff[4] = (unsigned char) hi(data);
                        /* byte 5 is data (ho) */
            cmdbuff[5] = (unsigned char) lo(data);
                        /* byte 5 is data (lo) */

            slave_wcmd(6, cmdbuff);
                        /* transmit response if not Broadcast mode */
            }
        return SUCCESS;
        }
    else {
#ifdef DEBUG
        printf("In slave_preset_4x, bad status from DBWRITE");
#endif
/* Also, transmit back exception response here if not Broadcast mode */
        if (!broadcast)
            send_exc_response(2, cmdbuff, repbuff);
                        /* bad address */
        return FAILURE;
        }
    }                   /* slave_preset_4x */

int slave_read_exc_status()
    {                   /* slave_read_exc_status */
    return SUCCESS;
    }                   /* slave_read_exc_status */

int slave_loopback()
    {                   /* slave_loopback */
    return SUCCESS;
    }                   /* slave_loopback */

int slave_force_0x_blk()
    {                   /* slave_force_0x_blk */
    return SUCCESS;
    }                   /* slave_force_0x_blk */

int slave_preset_4x_blk(cmdbuff, repbuff)
   /* Function to handle request for setting a multiple holding registers */
unsigned char repbuff[], cmdbuff[];
    {                   /* slave_preset_4x_blk */
    static int offset, quantity;
    static unsigned char *workptr;
    int broadcast;      /* if 1, broadcast mode, send no response */

#ifdef DEBUG
    printf("In slave_preset_4x_blk");
#endif

/*
 * We Received:        |    We will send:
 * ------------------------------------------------------
 * address             |    address
 * function            |    function
 * reg addr high       |    reg addr high
 * reg addr low        |    reg addr low 
 * data quantity high  |    data quantity high
 * data quantity low   |    data quantity low
 * byte count          |
 * data high    reg 1  |
 * data low            |
 * data high    reg 2  |
 * data low            |
 */
    swap((unsigned int *) &repbuff[2], 2);  /* fixup address and quantity */
    offset = *(int *) &repbuff[2];
    broadcast = !repbuff[0];    /* If broadcast mode, address is 0 */
    quantity = *(int *) &repbuff[4];    /* quantity in 16-bit WORDS, not bytes */

/*
 * validate quantity here.
 * If greater than 125 registers,
 * and not broadcast mode,
 * send back exception response
 */
    if ((quantity > 125) && (!broadcast)) {
        send_exc_response(3, cmdbuff, repbuff);
                        /* bad data */
        return FAILURE;
        }
    else {
#ifdef DEBUG
        printf("In slave_preset_4x_blk, offset=%X, quantity=%X", offset, quantity);
#endif
        workptr = (unsigned char *) &repbuff[0];
        workptr += 7;   /* skip addr/func/haddr/laddr/hqty/lqty/bytecount */

        swap((unsigned int *) workptr, quantity);
            /* swap database databytes ??? Yes, I really do think so... */

        if (back_dbwrite(offset, (unsigned int *) workptr, quantity) == 0) {
                        /* int offset, unsigned int *buffer, int quantity */

#ifdef DEBUG
            printf("In slave_preset_4x_blk, good status from DBWRITE");
#endif
            if (!broadcast) {
                        /* If not Broadcast mode, issue response */
                cmdbuff[0] = repbuff[0];
                        /* byte 1 is our slave # */
                cmdbuff[1] = repbuff[1];
                        /* byte 2 is function code */
                cmdbuff[2] = (unsigned char) hi(offset);
                        /* byte 3 is offset (ho)*/
                cmdbuff[3] = (unsigned char) lo(offset);
                        /* byte 4 is offset (lo) */
                cmdbuff[4] = (unsigned char) hi(quantity);
                        /* byte 5 is quantity (ho) */
                cmdbuff[5] = (unsigned char) lo(quantity);
                        /* byte 6 is quantity (lo) */

                slave_wcmd(6, cmdbuff);
                        /* transmit response */
                }
            return SUCCESS;
            }
        else {
#ifdef DEBUG
            printf("In slave_preset_4x_blk, bad status from DBWRITE");
#endif
/* Also, transmit back exception response here */
            if (!broadcast) /* If not Broadcast mode, issue response */
                send_exc_response(2, cmdbuff, repbuff);
                        /* bad address */
            return FAILURE;
            }
        }
    }                   /* slave_preset_4x_blk */


int slave_slave_id()
    {                   /* slave_slave_id */
    return SUCCESS;
    }                   /* slave_slave_id */

static int swap(T, qty)
unsigned int T[];
int qty;
    {                   /* swap */
    int i;
    unsigned int cswap;

    for (i = 0;  i < qty;  ) {
        cswap = T[i];
        cswap >>= 8;
        T[i] <<= 8;
        T[i++] |= cswap;
        }
    return SUCCESS;
    }                   /* swap */

int send_exc_response(code, cmdbuff, repbuff)
   /* Send exception response */
int code;               /* Error  code */
/*
 * Error Codes:
 * 1     Illegal Function
 * 2     Illegal Data Address
 * 3     Illegal Data Value
 * 4     Failure in associated device
 * 5     Acknowledge
 * 6     Busy, rejected message
 * 7     Nak-Negative acknowledgement
 */
unsigned char repbuff[], cmdbuff[];
    {                   /* send_exc_response */
    cmdbuff[0] = (unsigned char) repbuff[0];
                        /* byte 1 is our slave # */
    cmdbuff[1] = (unsigned char) repbuff[1] | 0x80;
                        /* byte 2 is function code plus exception bit */
    cmdbuff[2] = (unsigned char) code;  /* Error code */
    slave_wcmd(3, cmdbuff);
                        /* transmit response */
    return SUCCESS;
    }                   /* send_exc_response */

/******************* End of fslave.c **************************/

/*
This module contains the following functions:
back_dbread()
back_dbwrite()

*/

/*
global definitions

*/
#define RETURN_GOOD_STATUS  0           /*library call success*/
#define RETURN_BAD_STATUS   -1          /*library call error*/


/*
procedure back_dbwrite()

This procedure writes to the database structure which is contained in
the C996 memory.

back_dbwrite()
{
    if( offset + quantity is not within boundary of database )
        return( error );
    move data from buffer into database;
    return( good status );

}
*/

int back_dbwrite(offset, buffer, quantity)
int offset;
unsigned far *buffer;
int quantity;
    {
    long db_size;       /*size of database in words*/

    if (quantity > 255)
        return (RETURN_BAD_STATUS); /*return error*/

    db_size = (sizeof (this_database) * 2L);
                        /*get size in words (8 words/paragraph)*/

    if (((long) offset + (long) quantity) > db_size)
        return (RETURN_BAD_STATUS); /*not entirely within boundaries of database*/

    memmove((unsigned char *) this_database + (offset * 2), buffer, quantity * 2);

    return (RETURN_GOOD_STATUS);    /*return good status*/
    }


/*
procedure back_dbread()

This procedure reads from the database structure which is contained in
the C996 memory.

back_dbread()
{
    if( offset + quantity is not within boundary of database )
        return( error );
    move data from database into buffer;
    return( good status );

}
*/

int back_dbread(offset, buffer, quantity)
int offset;
unsigned far *buffer;
int quantity;
    {
    long db_size;       /*size of database in words*/

    if (quantity > 255)
        return (RETURN_BAD_STATUS); /*return error*/

    db_size = (sizeof (this_database) * 2L);
                        /*get size in words (8 words/paragraph)*/

    if (((long) offset + (long) quantity) > db_size)
        return (RETURN_BAD_STATUS); /*not entirely within boundaries of database*/

    memmove(buffer, (unsigned char *) this_database + (offset * 2), quantity * 2);

    return (RETURN_GOOD_STATUS);    /*return good status*/
    }


/*************************************************************************
* slave_wcmd  write given sequence of command bytes to slave network, and append
*       appropriate type of checksum (LRC or CRC) to the message end.
*************************************************************************/

int slave_wcmd(nbytes, cmdbuff)
int nbytes;             /* number of bytes to write     */
unsigned char cmdbuff[];    /* buffer of bytes to send      */
    {


    if (ncb_send(data_ncbp, nbytes, cmdbuff, 30) != 0) {
                        /*send the command*/
        printf("Send error: %d.", data_ncbp->NCB_RETCODE);
/*          ncb_close(data_ncbp);   close the path*/
        return 0x204;   /* "failure in associated device" */
        }
    else 
/*          return data_ncbp->NCB_RETCODE; */
        return 0;

    }

/*************************************************************************
* slave_rrep  read slave reply 
*************************************************************************/

int slave_rrep(n_bytes, repbuff)
int *n_bytes;           /* # of data bytes (ex chksum) read by rrep */
unsigned char repbuff[];    /* buffer to store the reply    */
/************************************************************************/
    {

    *n_bytes = 0;       /* initially set n_bytes to 0 */

    if (ncb_receive_wait(data_ncbp, repbuff, 30) != 0) {
                        /*try to receive*/
/*          printf("Receive error: %d.", nd->NCB_RETCODE); */
/*          ncb_close(nd);  close the path*/
        *n_bytes = 0;
        return 0x204;   /* "failure in associated device" */
        }
    else {
        *n_bytes = data_ncbp->NCB_LENGTH;
/*          return data_ncbp->NCB_RETCODE; */
        return 0;
        }
    }

/*************************************************************************
* hi    returns high order byte (in low order bits) of argument
*************************************************************************/

int hi(arg)
unsigned int arg;
    {
    return ((arg & 0xFF00) >> 8);
    }

/*************************************************************************
* lo    returns low order byte (in low order bits) of argument
*************************************************************************/

int lo(arg)
unsigned int arg;
    {
    return (arg & 0xFF);
    }

/*********************** end of testslav.c ************************/
