/* ****************************************************************************
 * Modbus Plus Display OS/2 Physical Device Driver Status Record
 * ***************************************************************************/


/* ****************************************************************************
 * COPYRIGHT (C) 1995, AEG SCHNEIDER AUTOMATION INC., ALL RIGHTS RESERVED.
 * NO PART OF THIS DOCUMENT MAY BE REPRODUCED IN ANY FORM WITHOUT THE
 * EXPRESSED WRITTEN PERMISSION OF AEG SCHNEIDER AUTOMATION INC.
 *
 *
 * program name:   BDSTATUS.EXE
 * revision:       
 * version:        3.00
 * eco number:     
 * release date:   
 *
 *
 *
 * R E V I S I O N   H I S T O R Y
 *
 * DATE   NAME    CHANGES
 *
 *****************************************************************************/

#define INCL_TYPES
#define INCL_BASE 
#define INCL_NOPMAPI                             /* don't include PM defs    */


#include <os2.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <mphost.h>


/*global variables */

    USHORT     ioStat;
    ULONG      actionTaken;
    UCHAR      adapterName[ 10 ];
    ULONG      fh;
    UCHAR      lan = 0;
    DDREQ      req;
    DDSTATUS   DDStat;

    ULONG  PListIN  = 0;                        /* dummy variable            */
    ULONG  PListOUT = 0;                        /* dummy variable            */
    ULONG  DListOUT = 0;                        /* dummy variable            */

    PVOID  pData_priv;


void main( argc, argv )
int argc;
char *argv[];
{


    printf( "BDSTATUS Modbus Plus - Display PDD status program. (NOT FOR DISTRIBUTE)\n" );
    printf( "Copyright(C) 1995, AEG Scneider Automation Inc. All Rights Reserved.\n\n" );

    if( argc > 1 && ( ( strcmpi( argv[ 1 ], "/h" ) == 0 ) ||
                      ( strcmpi( argv[ 1 ], "-h" ) == 0 ) ||
                      ( strcmpi( argv[ 1 ], "?" ) == 0 ) ) )
    {
        puts( "Usage is:" );
        puts( "    READNET <lan adapter #>" );
        puts( "    <lan adapter #> is 0 to 4" );
        exit( 1 );
    }

    memcpy( adapterName, "MPHOST0$", sizeof adapterName );

    if( argc > 1 )
    {                                   /* get routing info if present  */
      lan = (UCHAR) argv[ 1 ][0];
      adapterName[ 6 ] = (UCHAR) (lan | 0x30);
    }


    ioStat = DosOpen( adapterName,            /* name                */
                      &fh,                    /* file handle         */
                      &actionTaken,           /* action taken ?      */
                      0L,                     /* file size, if crea. */
                      FILE_NORMAL,            /* Attributes          */
                      OPEN_ACTION_OPEN_IF_EXISTS, /* Open mode       */
                      OPEN_ACCESS_READWRITE|      /* Open flags      */
                      OPEN_SHARE_DENYNONE|
                      OPEN_FLAGS_NOINHERIT|
                      OPEN_FLAGS_NO_CACHE,
                      0L);                    /* reserved            */


    if(ioStat) 
    {                                  /* check to see if board present */
        printf( "Modbus Plus board not found.\n" );
        exit( 1 );
    }
    else 
    {
       req.qlink     = NULL;
       req.reqver    = 0;
       req.cmpflg    = 0;
       req.status    = 0;
       req.cmplrt    = NULL;
       req.uservar   = 0;
       req.timeout   = -1L;
       req.cmd       = 0;
       req.pathid    = 0;
       req.buffsize  = sizeof( DDSTATUS );
       req.pbuffer   = (UCHAR *)&DDStat;

       ioStat = DosDevIOCtl(fh,                 /* device handle             */
                            CAT_IOCTLIN,        /* device category           */
                            DCMD_DEVSTATUS,     /* device function           */
                            NULL,               /* no paramert list          */
                            PListIN,            /* param list max len        */
                            &PListOUT,          /* param parm list           */                
                            (void*)&req,        /* ptr to MB+ buffer         */
                            sizeof(DDREQ),      /* data buffer length        */
                            &DListOUT);         /* data buffer length        */

        ioStat = DosClose(fh);

        printf("size of status record    :%d   ",DDStat.ssize);
        printf("version of status record :%d   \n",DDStat.sver);
        printf("IRQ line                 :%d   ",DDStat.irqchoice);
        printf("DP baseaddress           :%d   \n",DDStat.dpsegment);
        printf("LAN number               :%d   ",DDStat.lannumber);
        printf("Device Driver 'open' ctr.:%d   \n",DDStat.ddopencount);
        printf("Crash code               :%d   ",DDStat.crashcode);
        printf("Last Opcode              :%d   \n",DDStat.lastopcode);
        printf("Network node address     :%d   ",DDStat.nodeaddress);
        printf("Enhanced polled mode     :%d   \n",DDStat.enhancedpoll);
        printf("PM connect status        :%d   ",DDStat.pmcsmap);
        printf("PS slave login status    :%d   \n",DDStat.pslrmap);
        printf("DM open map              :%d   ",DDStat.dmopen);
        printf("DS open map              :%d   \n",DDStat.dsopen);
        printf("PM open map              :%d   ",DDStat.pmopen);
        printf("PS open map              :%d   \n",DDStat.psopen);
        printf("DM get response map      :%d   ",DDStat.dmgrmap);
        printf("DS get command map       :%d   \n",DDStat.dsgcmap);
        printf("PM get response map      :%d   ",DDStat.pmgrmap);
        printf("PS get command map       :%d   \n",DDStat.psgcmap);
        printf("GD present 01..08        :%d   ",DDStat.gdpmap[0]);
        printf("GD present 09..16        :%d   \n",DDStat.gdpmap[1]);
        printf("GD present 17..24        :%d   ",DDStat.gdpmap[2]);
        printf("GD present 25..32        :%d   \n",DDStat.gdpmap[3]);
        printf("GD present 33..40        :%d   ",DDStat.gdpmap[4]);
        printf("GD present 41..48        :%d   \n",DDStat.gdpmap[5]);
        printf("GD present 49..56        :%d   ",DDStat.gdpmap[6]);
        printf("GD present 57..64        :%d   \n",DDStat.gdpmap[7]);
        printf("DM response deferred map :%d   ",DDStat.dmgrdef);
        printf("DS command deferred map  :%d   \n",DDStat.dsgcdef);
        printf("PM response deferred map :%d   ",DDStat.pmgrdef);
        printf("PS command deferred map  :%d   \n",DDStat.psgcdef);
        printf("DM routing failure map   :%d   ",DDStat.dmrtfpnd);
        printf("DS routing failure map   :%d   \n",DDStat.dsrtfpnd);
        printf("PM routing failure map   :%d   ",DDStat.pmrtfpnd);
        printf("PS routing failure map   :%d   \n",DDStat.psrtfpnd);

    }
}