/*
mbpcheck.c

This program checks to see if any modbus plus adapters are installed.
*/

/* include */
#include <stdio.h>
#include <netbios.h>
#include <netlib.h>

/* prototypes */
void main( void );

/* global vars. */
NCB n_c_b;                          /* allocate an NCB */
unsigned char mbuffer[ 256 ];       /* allocate buffer area for response */
short lan_number;
short peer_number;

/*
main

This code module checks to see if any modbus plus interfaces are present.
*/

void main() {

    for(lan_number = 0; lan_number < 4; lan_number++)
    {
       n_c_b.NCB_BUFFER = &mbuffer[ 0 ];
       if( ncb_status( &n_c_b, lan_number ) != 0 ) 
       {
           printf( "MODBUS PLUS Adapter %d board not found.\n", lan_number );
       }
       else 
       {
           peer_number = ( short ) mbuffer[ 6 ];
           printf( "MODBUS PLUS Adapter %d identified as node %d.\n",lan_number, peer_number );
       }
    }
}

