/*name test4.c*/

                                  
/*
This test program uses the MPHOST.SYS device driver 
and the MPHOST32.DLL Dynalink library to read 125 holding
registers from the MODBUS slave which is found at the given node number.

In order to use this program, enter the following command:

    A>TEST4 <slave node#> [<adaptor #>]
    
    e.g.  TEST4 12

where "12" is the slave node we want to read from, default adapter # 0.
*/


/*
include


*/

#define INCL_DOS
#define INCL_SUB
#define INCL_DOSMISC       /* DOS Miscellaneous values */
#define INCL_DOSERRORS     /* DOS Error values         */
#define INCL_DOSPROCESS

#include <os2.h>

#include <stdio.h>
#include <process.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include "netbios.h"
#include "netlib.h"


/*
prototypes

*/
int main(int argc, char *argv[]);
void dump(short qty, unsigned char *buff);
extern void FAR box(PBYTE cb, short x1, short y1, short x2, short y2, PUCHAR name);
extern void FAR ExpBox(BYTE *cb, short x1, short y1, short x2, short y2, char *name);


/*
macros

*/
#define LENGTH 200       /* length of string buffer */
#define HANDLE 0        /* vio handle always 0 */

/*
global variables


*/
/* char mbuffer[256];*/
char mbuffer[512];
char path[80];
char last_fore_or_back = ' ', fore_or_back;

struct performance_record 
    {
    long sys_msec_start;
    long count_start;
    long sys_msec_end;
    long count_end;
    long period_count;
    long time_diff;
    double trans_per_sec;
    char fore_or_back;
    unsigned char hours;
    unsigned char minutes;
    unsigned char seconds;
    } performance_record[10];

/*
main()


*/

int main(argc, argv)
int argc;
char *argv[];
    {
    NCB *nd;
    short ret_val;
    short node_adr;
    char buffer[LENGTH], buffer2[LENGTH];
    unsigned char attr = 0x70;  /* reverse video attribute */
    unsigned blank = 0x7020;    /* reverse video, blank char */
    long count = 0L;
    unsigned Cell = 0x720;  /* for scrolling */
    short sAPS = 0;
 
   PTIB    ptib                = NULL;      /* thread ID block                */
   PPIB    ppib                = NULL;      /* proces ID block                */
   ULONG   aulSysInfo[QSV_MAX] = {0};       /* System Information Data Buffer */
   ULONG   PIDForeground       = 0;         /* PID of foreground session      */ 
   ULONG   PIDruntime          = 0;         /* process runtime in msec        */
   APIRET  rc                  = NO_ERROR;  /* Return code                    */


    struct _KBDKEYINFO kbddata;
    struct _DATETIME datetime;
    unsigned char reset_counters = 0;
    short lan_number = 0;   /* default is LAN adapter #0 */


    /*
     * Develop pointers to local and global info segments:
     */


   DosGetInfoBlocks(&ptib,&ppib);     /* get the proces and thread ID blocks */


    VioScrollUp(0, 0, -1, -1, -1, (PBYTE) &Cell, 0);
                        /* clear the screen */

/*    box((PBYTE) &blank, 2, 1, 38, 7, " << TEST4 >> ");*/
/*  ExpBox((BYTE *) &blank, 2, 1, 38, 7, " << TEST4 >> ");*/

    sprintf(buffer, "        <<  TEST4  >>");
    VioWrtCharStrAtt(buffer, strlen(buffer), 2, 3, &attr, HANDLE);
    sprintf(buffer, "SCHNEIDER AUTOMATION:  MODBUS+ Command/Response test.     ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 3, 3, &attr, HANDLE);
    sprintf(buffer, "[Reads 125 Holding Registers from Slave Node]");
    VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);

/*    box((PBYTE) &blank, 39, 1, 76, 7, " Help ");*/
/*  ExpBox((BYTE *) &blank, 39, 1, 76, 7, " Help ");*/

/*
    sprintf(buffer,"                                   ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 3, 40, &attr, HANDLE);
*/
    sprintf(buffer, "Space bar clears current counters. ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 5, 40, &attr, HANDLE);
    sprintf(buffer, "'Q' terminates program.            ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 6, 40, &attr, HANDLE);
    sprintf(buffer, "                                   ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 7, 40, &attr, HANDLE);
    VioWrtCharStrAtt(buffer, strlen(buffer), 8, 40, &attr, HANDLE);

    switch (argc) {
    case 0:
    case 1:
        sprintf(buffer, "Usage is: A>TEST4 <slave node> <LAN adapter#>");
        VioWrtCharStrAtt(buffer, strlen(buffer), 9, 3, &attr, HANDLE);
        VioSetCurPos(10, 1, HANDLE);
        exit(1);
        break;
    case 2:
        lan_number = 0; /* default */
        break;
    case 3:
        ret_val = sscanf(argv[2], "%d", &lan_number);
        if ((lan_number < 0) || lan_number > 3) {
            sprintf(buffer, "LAN adapter # must be 0 .. 3. ");
            VioWrtCharStrAtt(buffer, strlen(buffer), 9, 3, &attr, HANDLE);
            VioSetCurPos(10, 1, HANDLE);
            exit(1);
            }
        break;
    default:
        sprintf(buffer, "Usage is: A>TEST4 <slave node> <LAN adapter#>");
        VioWrtCharStrAtt(buffer, strlen(buffer), 9, 3, &attr, HANDLE);
        VioSetCurPos(10, 1, HANDLE);
        exit(1);
        break;
        }

    ret_val = sscanf(argv[1], "%d", &node_adr);
    if (ret_val != 1 || node_adr < 1 || node_adr > 64) {
        sprintf(buffer, "Node number must be in the range 1 to 64. ");
        VioWrtCharStrAtt(buffer, strlen(buffer), 9, 3, &attr, HANDLE);
        VioSetCurPos(10, 1, HANDLE);
        exit(1);
        }
    sprintf(path, "DM.%d.0.0.0.0", node_adr);
    VioWrtCharStrAtt(buffer, strlen(buffer), 9, 3, &attr, HANDLE);

    if ((nd = ncb_open(path, lan_number)) == NULL) {
        sprintf(buffer, "Unable to open DATA MASTER path.");
        VioWrtCharStrAtt(buffer, strlen(buffer), 10, 3, &attr, HANDLE);
        VioSetCurPos(11, 1, HANDLE);
        exit(1);
        }
    sprintf(buffer, "Path %02X opened    LAN adapter# %d   ", nd->NCB_NUM, lan_number);
    VioWrtCharStrAtt(buffer, strlen(buffer), 10, 3, &attr, HANDLE);

    sprintf(buffer, "Routing info: %c%c.%d.%d.%d.%d.%d         ",
        nd->NCB_CALLNAME[0],
        nd->NCB_CALLNAME[1],
        nd->NCB_CALLNAME[2],
        nd->NCB_CALLNAME[3],
        nd->NCB_CALLNAME[4],
        nd->NCB_CALLNAME[5],
        nd->NCB_CALLNAME[6]);
    VioWrtCharStrAtt(buffer, strlen(buffer), 11, 3, &attr, HANDLE);
    sprintf(buffer, "Destination node: %d                ", node_adr);
    VioWrtCharStrAtt(buffer, strlen(buffer), 12, 3, &attr, HANDLE);

/*    box((PBYTE) &blank, 1, 10, 79, 23, " Current / Foreground / Background Statistics ");*/
/*  ExpBox((BYTE *) &blank, 1, 10, 79, 23, " Current / Foreground / Background Statistics ");*/

    for (;;) 
   {
        count++;

/*
 * If we're foreground task don't hog the cpu
 */

      rc = DosQuerySysInfo(1L,                 /* Request all available system   */
                           QSV_MAX,            /* information                    */
                           (PVOID)aulSysInfo,
                           sizeof(ULONG)* QSV_MAX);
    
      if (rc == NO_ERROR) 
      {
         PIDForeground = aulSysInfo[QSV_FOREGROUND_PROCESS-1];
         PIDruntime    = aulSysInfo[QSV_MS_COUNT-1];
      } 
      else
      {
         return(0);
      }


        if (PIDForeground == ppib->pib_ulpid)
            DosSleep(32L); /* Relinquish rest 32 msec */

        if ((ppib->pib_ulpid == PIDForeground)/*||(ppib->pib_ulppid == PIDForeground)*/)
                fore_or_back = 'f'; /* we're the FOREGROUND task */
        else 
                fore_or_back = 'b'; /* we're the BACKGROUND task */

        if ((fore_or_back != last_fore_or_back) || (reset_counters)) 
      {
            performance_record[1] = performance_record[0];
                        /* scroll history into forward cell */

            /*
             * Record starting info for current frame:
             */
            performance_record[0].fore_or_back = fore_or_back;
            performance_record[0].sys_msec_start = PIDruntime;
            performance_record[0].count_start = count;
            DosGetDateTime(&datetime);
            performance_record[0].hours = datetime.hours;
            performance_record[0].minutes = datetime.minutes;
            performance_record[0].seconds = datetime.seconds;

            /*
             * Fill in ending info for previous frame:
             */
            performance_record[1].sys_msec_end = PIDruntime;
            performance_record[1].count_end = count;
            performance_record[1].period_count = performance_record[1].count_end - performance_record[1].count_start;
            performance_record[1].time_diff = performance_record[1].sys_msec_end - performance_record[1].sys_msec_start;
            performance_record[1].trans_per_sec = (double) performance_record[1].period_count / ((double) performance_record[1].time_diff / 1000.0);

            if (performance_record[1].period_count > 2) {
                        /* don't display empty records */
                VioScrollDn(12, 3, 22, 78, 1, (PBYTE) &blank, HANDLE);
                if (performance_record[1].fore_or_back == 'f')
                    strcpy(buffer, "Fore ");
                else 
                    strcpy(buffer, "Back ");

                sprintf(buffer2, "%#6.2f/sec count=%8ld  elapsed=%#08.1f sec. start @ %02u:%02u:%02u ",
                    performance_record[1].trans_per_sec,
                    performance_record[1].period_count,
                    ((double) performance_record[1].time_diff / 1000.0),
                    performance_record[1].hours,
                    performance_record[1].minutes,
                    performance_record[1].seconds);
                    strcat(buffer, buffer2);
                   if (strlen(buffer) > 81)
                       buffer[80] = 0;  /* limit length */
                   VioWrtCharStrAtt(buffer, strlen(buffer), 14, 3, &attr, HANDLE);
            }
            last_fore_or_back = fore_or_back;
            reset_counters = 0;
            kbddata.chChar = 0;
        }

        /*
         * Now if we're Foreground, update screen:
         */
/*      if (fore_or_back == 'f') {*/
        if (1){

            DosGetDateTime(&datetime);

            if (count - performance_record[0].count_start > 2) {
                        /* don't display empty record */

                sprintf(buffer,
                    "Curr %#6.2f/sec count=%8ld  elapsed=%#8.1f sec. start @ %02u:%02u:%02u     ",
                    (double) (count - performance_record[0].count_start) / 
                    ((double) (PIDruntime - performance_record[0].sys_msec_start) / 1000.0),
                    (count - performance_record[0].count_start),
                    ((double) (PIDruntime - performance_record[0].sys_msec_start) / 1000.0),
                    performance_record[0].hours,
                    performance_record[0].minutes,
                    performance_record[0].seconds);
                if (strlen(buffer) > 81)
                    buffer[80] = 0; /* limit length */
                VioWrtCharStrAtt(buffer, strlen(buffer), 15, 3, &attr, HANDLE);
                }
            }

        /*
         * Note: filling in mbuffer[0] with the slave address
         * is actually unecessary, since it was specified above
         * in the ncb_open.  It can be done here, since the buffer
         * pointer is adjusted by 1 in ncb_send, to provide ease-of-use
         * and compatibility with existing modbus(I) applications.
         */
/*      mbuffer[0] = 0;     slave address, for compatibility with old s/w */
        mbuffer[1] = 0x3;   /*command*/
        mbuffer[2] = 0x0;   /*offset high*/
        mbuffer[3] = 0x0;   /*offset low*/
        mbuffer[4] = 0x0;   /*reg count high*/
        mbuffer[5] = 125;   /* reg count low*/

        if ((sAPS = ncb_send(nd, 6, mbuffer, 10)) != 0) {
            if(sAPS == -1){/* Bad Path */
		    sprintf(buffer, "Bad Path Detected");
		    VioWrtCharStrAtt(buffer, strlen(buffer), 14, 3, &attr, HANDLE);
		    VioSetCurPos(15, 1, HANDLE);
		    exit(1);
	    }
	    else
	    {
		/*send the command*/
		sprintf(buffer, "Send error: %d.", nd->NCB_RETCODE);
		VioWrtCharStrAtt(buffer, strlen(buffer), 14, 3, &attr, HANDLE);
                ret_val = ncb_close(nd);    /*close the path*/
                VioSetCurPos(15, 1, HANDLE);
                exit(1);
	    }
        }
        if (ncb_receive_wait(nd, mbuffer, 20) != 0) {
                        /*try to receive*/
            sprintf(buffer, "Receive error: %d.", nd->NCB_RETCODE);
            VioWrtCharStrAtt(buffer, strlen(buffer), 14, 3, &attr, HANDLE);
            ret_val = ncb_close(nd);    /*close the path*/
            VioSetCurPos(15, 1, HANDLE);
	    exit(1);
            }
/*      dump(256,mbuffer); */

        /* (kbhit() doesn't update 'foreground' indicator) */
        KbdCharIn(&kbddata, 1, HANDLE); /* 1==no wait */
        if (kbddata.chChar)
            if (kbddata.chChar == ' ')
                reset_counters = 1;
            else 
                if (tolower(kbddata.chChar) == 'q'){
                    sprintf(buffer, "<< TEST4 TERMINATED NORMALLY >>");
                    VioWrtCharStrAtt(buffer, strlen(buffer), 18, 1, &attr, HANDLE);
                    ncb_close(nd);  /*close the path*/
                    VioSetCurPos(19, 1, HANDLE);
                    KbdFlushBuffer(HANDLE);
                    exit(0);
                    }
        }
    ncb_close(nd);      /*close the path*/
    exit(0);
    return (0);
    }

#if 0
void dump(qty, buff)
short qty;                /* qty of bytes to dump */
unsigned char *buff;    /* buffer with the data */
    {                   /* dump_lines */
    short i = 0, j;

    fprintf(stdout, "\n");
    do  {
        fprintf(stdout, "\n");
        for (j = 0;  j < 16;  j++,  i++)
            fprintf(stdout, "%02X ", (unsigned) *(buff + i));
        }
    while (i < qty);
    fprintf(stdout, "\n");
    }                   /* dump_lines */

#endif


/******************** End of TEST4.C ********************************/
