/*name test4c.c*/

/*
 * This program is meant to be used in conjunction with TESTSLAV.C.
 * It generates the modbus requests that TESTSLAV will service.
 * Usage is TEST4C <slave node #> <path #> [<adapter #>]
 * eg. TEST4C 12 1
 * send to path 1 of node #12, default adapter # 0
 */


/*include*/

#define INCL_SUB
#define INCL_DOS
#include <os2.h>

#include <stdio.h>
#include <process.h>
#include <string.h>
#include <conio.h>
#include "netbios.h"
#include "netlib.h"


/*prototypes*/

int main(int argc, char *argv[]);


/*global variables*/

char mbuffer[256];
#define LENGTH 81       /* length of string buffer */
#define HANDLE 0        /* vio handle always 0 */


/*main()*/

int main(argc, argv)
int argc;
char *argv[];
    {
    NCB *nd;
    int ret_val, node_adr, slave_path, lan_number;
    char buffer[LENGTH];
    char path[80];
    unsigned char attr = 0x70;  /* reverse video attribute */
    long lmsgcnt = 0L;
    long lrcverrs = 0L;
    long lsnderrs = 0L;
    unsigned Cell = 0x0720; /* for scrolling */
    unsigned int i, ier=0;

    VioScrollUp(0,0,-1,-1,-1,(char *)&Cell,0); /* clear the screen */

    sprintf(buffer,"        << TEST4C >>                    ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 2, 3, &attr, HANDLE);
    sprintf(buffer,"SCHNEIDER AUTOMATION: Master Module for Modbus+ OS/2  ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 3, 3, &attr, HANDLE);
    sprintf(buffer,"[ Used as Master to Testslav.exe ] ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);


    switch (argc) 
    {
      case 0:
      case 1:
      case 2:
      		sprintf(buffer, "Usage is: A>TEST4C <slave node> <path #> <LAN adapter#>");
      		VioWrtCharStrAtt(buffer, strlen(buffer), 9, 3, &attr, HANDLE);
      		VioSetCurPos(9, 1, HANDLE);
      		exit(1);
      		break;
      case 3:
      		lan_number = 0;	/* default */
		      break;
      case 4:
      		ret_val = sscanf(argv[3], "%d", &lan_number);
      		if (lan_number != 0 && lan_number != 1) 
            {
      			sprintf(buffer, "LAN adapter # must be 0 or 1. ");
      			VioWrtCharStrAtt(buffer, strlen(buffer), 9, 3, &attr, HANDLE);
      			VioSetCurPos(9, 1, HANDLE);
      			exit(1);
   			}
      		break;
      default:
	        sprintf(buffer, "Usage is: A>TEST4C <slave node> <path #> <LAN adapter#>");
      		VioWrtCharStrAtt(buffer, strlen(buffer), 9, 3, &attr, HANDLE);
      		VioSetCurPos(9, 1, HANDLE);
      		exit(1);
      		break;
		}

	ret_val = sscanf(argv[1], "%d", &node_adr);
	if (ret_val != 1 || node_adr < 1 || node_adr > 64) 
   {
		sprintf(buffer, "Node number must be in the range 1 to 64. ");
		VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);
		VioSetCurPos(6, 1, HANDLE);
		exit(1);
	}

	ret_val = sscanf(argv[2], "%d", &slave_path);

	if (ret_val != 1 || slave_path < 1 || slave_path > 8) 
   {
		sprintf(buffer, "Slave path number must be in the range 1 to 8. ");
		VioWrtCharStrAtt(buffer, strlen(buffer), 5, 3, &attr, HANDLE);
		VioSetCurPos(6, 1, HANDLE);
		exit(1);
	}

                                        

/*  ncb_reset(0);   start by resetting the board */
/*
 * Note that here what we are doing is establishing the routing
 * to the slave path y on a SA85-based PC at node x.
 * (The particular slave path on an SA85 is EXPLICITLY selected,
 * unlike a 685).
 */

    sprintf(path,"DM.%d.%d.0.0.0",node_adr,slave_path);

    if ((nd = ncb_open(path, lan_number)) == NULL) 
    {
        sprintf(buffer,"Unable to open DATA MASTER path.");
        VioWrtCharStrAtt(buffer, strlen(buffer), 5, 3, &attr, HANDLE);
        VioSetCurPos(23,1,HANDLE);
        exit(1);
    }

    sprintf(buffer,"Path %02X opened", nd->NCB_NUM);
    VioWrtCharStrAtt(buffer, strlen(buffer), 5, 3, &attr, HANDLE);
    sprintf(buffer,"Routing info: %c%c.%d.%d.%d.%d.%d",
        nd->NCB_CALLNAME[0],
        nd->NCB_CALLNAME[1],
        nd->NCB_CALLNAME[2],
        nd->NCB_CALLNAME[3],
        nd->NCB_CALLNAME[4],
        nd->NCB_CALLNAME[5],
        nd->NCB_CALLNAME[6]);
    VioWrtCharStrAtt(buffer, strlen(buffer), 6, 3, &attr, HANDLE);

    while( !kbhit() ) 
    {
/*      mbuffer[0] = 0x5; */  /*slave address - doesn't have to be filled in */
	mbuffer[1] = 0x3;   /*command*/ /*Read Registers*/
	mbuffer[2] = 0x0;   /*offset high*/
	mbuffer[3] = 0x0;   /*offset low*/
        mbuffer[4] = 0x0;   /*reg count high*/
	mbuffer[5] = 125;   /* reg count low*/
	
	
/*--- attempting to send on path nd->NCB_NUM --------------------------------*/

        sprintf(buffer, "# of Sends: %ld           ", ++lmsgcnt);
        VioWrtCharStrAtt(buffer, strlen(buffer), 7, 3, &attr, HANDLE);

/*--- send the command ------------------------------------------------------*/

        if (ncb_send(nd, 6, mbuffer, 10) != 0)
        {
	    sprintf(buffer,"# Send Errors:    %ld", ++lsnderrs);
            VioWrtCharStrAtt(buffer, strlen(buffer), 8, 3, &attr, HANDLE);

	    sprintf(buffer,"Send #    %ld, Error Code:    %d.", lmsgcnt,nd->NCB_RETCODE);
            VioWrtCharStrAtt(buffer, strlen(buffer), 9, 30, &attr, HANDLE);
            ncb_cancel(nd);
            ret_val = ncb_close(nd);
            VioSetCurPos(11,1,HANDLE);
            exit(1); /* For now, exit on send error */
	}
	    sprintf(buffer,"# Send Errors:    %ld", lsnderrs);
            VioWrtCharStrAtt(buffer, strlen(buffer), 8, 3, &attr, HANDLE);

/*--- attempting to receive on path nd->NCB_NUM -----------------------------*/

	if (ncb_receive_wait(nd, mbuffer, 20) != 0) 
        {
            sprintf(buffer,"# Receive Errors:    %ld", ++lrcverrs);
            VioWrtCharStrAtt(buffer, strlen(buffer), 9, 3, &attr, HANDLE);
    	    sprintf(buffer,"Last error -> Receive #    %ld, Error Code:    %d",lmsgcnt, nd->NCB_RETCODE);
            VioWrtCharStrAtt(buffer, strlen(buffer), 10, 3, &attr, HANDLE);

#ifdef PRINTMBUFF
        printf( "\nMessage received is %d bytes as follows:\n", nd->NCB_LENGTH );  
        for( i = 0; i < nd->NCB_LENGTH; i++ ) 
		{
			if( ( i % 16 ) == 0 )
				printf( "\n%05d :", i );
			printf( "  %02X", (unsigned short) mbuffer[ i ] );
		}
#endif

        }


    }
/*--- close the path --------------------------------------------------------*/

    ncb_close(nd);

    VioSetCurPos(11,1,HANDLE);
    exit(0);

    return 0;
    }




