#define INCL_SUB
#include <os2.h>

#include <stdio.h>
#include <time.h>
#include <process.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <conio.h>
#include "netbios.h"
#include "netlib.h"
#include "testslav.h"

/*
prototypes
*/
int main(short argc, char *argv[]);
short allocate_paths(unsigned char address);

short fslave6(unsigned short tblbuff[], 
            unsigned char cmdbuff[],
            unsigned char repbuff[],
            unsigned short dbuff[]);

extern short hi(unsigned short arg);
extern short lo(unsigned short arg);
extern short send_exc_response(short code, unsigned char *cmdbuff, unsigned char *repbuff);
extern short fslave(unsigned short *tblbuff, unsigned char *cmdbuff, unsigned char *repbuff, unsigned short *dbuff);
extern short decode_modbus_msg(unsigned char *cmdbuff, unsigned char *repbuff, unsigned short *dbuff);
extern short slave_read_0x(void);
extern short slave_read_1x(void);
extern short slave_read_4x(unsigned char *cmdbuff, unsigned char *repbuff, unsigned short *dbuff);
extern short slave_read_3x(void);
extern short slave_force_0x(void);
extern short slave_preset_4x(unsigned char *cmdbuff, unsigned char *repbuff);
extern short slave_read_exc_status(void);
extern short slave_loopback(void);
extern short slave_force_0x_blk(void);
extern short slave_preset_4x_blk(unsigned char *cmdbuff, unsigned char *repbuff);
extern short slave_slave_id(void);
extern short slave_wcmd(short nbytes, unsigned char *cmdbuff);
extern short slave_rrep(short *n_bytes, unsigned char *repbuff);
extern short back_dbread(long offset, unsigned short *buffer, long quantity);
extern short back_dbwrite(short offset, unsigned short *buffer, short quantity);

#ifdef InstantC
unsigned short this_database[100]; 
#else
unsigned short this_database[10000];
#endif
NCB *data_ncbp, dummyncb;
unsigned char mbuffer[ 256 ];

#define LENGTH 81       /* length of string buffer */
#define HANDLE 0        /* vio handle always 0 */

struct dxparamst DMA_area;
unsigned short *T = (unsigned short *) &DMA_area.table[0];
unsigned char cmdbuff[524], repbuff[524];
unsigned short dbuff[256];
char buffer[LENGTH];
unsigned long lmsgcnt = 0L; /* number of queries received */
/*
 * DEBUG enables very nice debugging displays, if defined
 */
/* #define DEBUG   1 */


unsigned char attr = 0x70;  /* reverse video attribute */

int main(argc, argv)
   short argc;
   char *argv[];

{
    int i;
    unsigned Cell = 0x0720; /* for scrolling */
    char path[80];
    short node_adr, ret_val, slave_path, lan_number;
    
    for (i=0; i<(sizeof(this_database)/2); i++)
    {
	    this_database[i] = i;
    }
    VioScrollUp(0,0,-1,-1,-1,(char *)&Cell,0); /* clear the screen */

    sprintf(buffer,"        << TESTSLAV >>                      ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 2, 3, &attr, HANDLE);
    sprintf(buffer,"SCHNEIDER AUTOMATION -- Slave Module for Modbus+ OS/2   ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 3, 3, &attr, HANDLE);

    switch (argc) 
    {
	case 0:
	case 1:
		sprintf(buffer, "Usage is: A>TESTSLAV <slave path> <LAN adapter#>");
		VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);
		VioSetCurPos(5, 1, HANDLE);
		exit(1);
		break;
	case 2:
		lan_number = 0;	/* default */
		break;
	case 3:
		ret_val = sscanf(argv[2], "%d", &lan_number);
		if (lan_number != 0 && lan_number != 1) 
      {
			sprintf(buffer, "LAN adapter # must be 0 or 1. ");
			VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);
			VioSetCurPos(5, 1, HANDLE);
			exit(1);
		}
		break;
	default:
		sprintf(buffer, "Usage is: A>TESTSLAV <slave path> <LAN adapter#>");
		VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);
		VioSetCurPos(5, 1, HANDLE);
		exit(1);
		break;
	}

	ret_val = sscanf(argv[1], "%d", &slave_path);
	if (ret_val != 1 || slave_path < 1 || slave_path > 8) 
   {
		sprintf(buffer, "Slave path must be in the range 1 to 8. ");
		VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);
		VioSetCurPos(5, 1, HANDLE);
		exit(1);
	}


    dummyncb.NCB_BUFFER = &mbuffer[ 0 ];

    if( ncb_status( &dummyncb, lan_number) != 0 ) 
    {
       sprintf(buffer,"MODBUS PLUS Adapter board %d not found.  ",lan_number);
       VioWrtCharStrAtt(buffer, strlen(buffer), 4, 3, &attr, HANDLE);
       VioSetCurPos(5, 1, HANDLE);
       exit(1);

    }
    else 
    {
        node_adr = ( short ) mbuffer[ 6 ];
        sprintf(buffer,"MODBUS PLUS Adapter %d identified as node %d.",lan_number,node_adr);
        VioWrtCharStrAtt(buffer, strlen(buffer), 5, 3, &attr, HANDLE);
    }

    sprintf(path,"DS.%d.0.0.0.0",slave_path);

    if ((data_ncbp = ncb_open(path, lan_number)) == NULL) 
    {
        sprintf(buffer,"Unable to open DATA SLAVE path (internal).");
        VioWrtCharStrAtt(buffer, strlen(buffer), 7, 3, &attr, HANDLE);
        VioSetCurPos(8,1,HANDLE);
        exit(1);
    }

    for (;  ;) 
    {
        /* loop repeatedly */

        T[0] = 6;       /* port "6" is SA85 Modbus Plus */
        T[1] = node_adr;    /* we're slave address #12 */
        T[2] = T[3] = 0;    /* don't use these, set them to zero */
        T[4] = 0;       /* doesn't matter */
        
        if (fslave6(T, cmdbuff, repbuff, dbuff) != DXDONE){
		/* We found no incoming message */
		
		sprintf(buffer,"Slave Status  =  0x%X      ", T[5]);
		VioWrtCharStrAtt(buffer, strlen(buffer), 6, 3, &attr, HANDLE);
	}
	else{
		lmsgcnt++; /* Increment count of number messages received from master */
		sprintf(buffer,"Receiving Messages...      ");
		VioWrtCharStrAtt(buffer, strlen(buffer), 6, 3, &attr, HANDLE);

	}

        sprintf(buffer, "# of Slave requests serviced:     %ld", lmsgcnt);
	VioWrtCharStrAtt(buffer, strlen(buffer), 7, 3, &attr, HANDLE);




	if (kbhit()) 
        {
            sprintf(buffer, "<< TESTSLAV TERMINATED NORMALLY >>");
            VioWrtCharStrAtt(buffer, strlen(buffer), 9, 3, &attr, HANDLE);
            sprintf(buffer, "                                  ");
            VioWrtCharStrAtt(buffer, strlen(buffer), 10, 3, &attr, HANDLE);
            getch();
            ncb_close(data_ncbp);  /*close the path*/
            VioSetCurPos(11,1,HANDLE);
            exit(0);
        }
    }
    return 0;
}

static short swap(unsigned short *, short);
static short clength;     /* required only when #DEBUG defined */


/****************************************************************************
*  f_slave          
*  Simulate Modbus Slave
*  Calling this block will look for a Modbus message on the communications port.
*  If a good (supported) Modbus message, and we're the correct slave,
*       the approprate Modbus slave function will be called.
*  Current status will be returned in tblbuff[5].
*  Received Modbus function number will be returned in tblbuff[6].
*****************************************************************************/
/*    char error_text[80];   goes with decode_status - not needed here */

/* CALL block table of registers: register offsets                      */
/* tblbuff[0] PORT          0     Modbus slave port to use (1-6) on Co-Pro  */
/* tblbuff[1] SLAVE         1     USER: Slave # we'll pretend to be         */
/* tblbuff[2] ADDRESS       2     not used  (in master, USER: Slave data address) */
/* tblbuff[3] QUANTITY      3     not used  (in master, USER: quantity of regs in/out */
/* tblbuff[4] MODE          4     not used  (in master, USER: 0 = ASCII  1 = RTU mode(relaxed timing only)) */
/* tblbuff[5] M_STATUS      5     Modbus slave status word - statuses appear here */
/* tblbuff[6] DATA1         6     function number for Modbus message received */
/*            (all other data regs follow)                              */


short fslave6(tblbuff, cmdbuff, repbuff, dbuff)
   unsigned short tblbuff[];
   unsigned char repbuff[], cmdbuff[];
   unsigned short dbuff[];
{

    static short nbytes;  /* # bytes read from slave      */

    tblbuff[M_STATUS] = slave_rrep(&nbytes, repbuff);

/*              decode_status(reply_status, error_text); */
/* decode and report on reply_status */
/* not needed here, was used in MSDOS version - see MTERM.C Modbus Terminal Emulator */

    if (tblbuff[M_STATUS] == 0) 
    {

	/* now decode the good Modbus message */

/* Only question is, decode_modbus_msg returns success or no success. */
/* How do we treat that status here ? */

        clength = nbytes;
        decode_modbus_msg(cmdbuff, repbuff, dbuff);
                          /* pass address, Co-Pro Port to use */
        tblbuff[DATA1] = repbuff[DATA1];    /* received Modbus function_no number is returned in tblbuff[1] */
        return DXDONE;
    }
    else 
/* This is one place we might want to CONSIDER issuing an exception response */
        return DXERROR; /* Bad Modbus message received */
}

short decode_modbus_msg(cmdbuff, repbuff, dbuff)
   unsigned char *repbuff, *cmdbuff;
   unsigned short *dbuff;

{                   /* decode_modbus_msg */

#ifdef DEBUG
    short i, length;
#endif

#ifdef DEBUG
    sprintf(buffer,"** Good Modbus message received: ");
    VioWrtCharStrAtt(buffer, strlen(buffer), 10, 3, &attr, HANDLE);
    length = clength;
    for (i = 0;  i < length;  i++) {
        if (repbuff[i] < 0x10)
            sprintf(buffer,"0");    /* leading zero, if necessary */
        sprintf(buffer,"%X", (unsigned short) repbuff[i]);
        }
    VioWrtCharStrAtt(buffer, strlen(buffer), 11, 50, &attr, HANDLE);
    sprintf(buffer,"     for address: 0x%X   function 0x%X ", repbuff[0], repbuff[1]);
    VioWrtCharStrAtt(buffer, strlen(buffer), 12, 3, &attr, HANDLE);
#endif
/*************************************************************************/
    switch (repbuff[1]) {
/*************************************************************************/
    case 1:             /* Modbus code 01 - read output status */
#ifdef DEBUG
        printf("\n     ** Request for unimplemented function ** Modbus code 01 - read output status");
        printf("\n     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("\n     quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_read_0x(); */
        break;
/*************************************************************************/
    case 2:             /* Modbus code 02 - read input status */
#ifdef DEBUG
        printf("\n     ** Request for unimplemented function ** Modbus code 02 - read input status");
        printf("\n     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("\n     quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_read_1x(); */
        break;
/*************************************************************************/
    case 3:             /* Modbus code 03 - read output registers */
#ifdef DEBUG
        printf("\n     Modbus code 03 - read output registers");
        printf("\n     address(high): 0x%X    address(low) 0x%X\n ", repbuff[2], repbuff[3]);
        printf("\n     quantity(high): 0x%X   quantity(low) 0x%X\n ", repbuff[4], repbuff[5]);
#endif
        return (slave_read_4x(cmdbuff, repbuff, dbuff));
        break;
/*************************************************************************/
    case 4:             /* Modbus code 04 - read input registers */
#ifdef DEBUG
        printf("\n     ** Request for unimplemented function ** Modbus code 04 - read input registers");
        printf("\n     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("\n     quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_read_3x(); */
        break;
/*************************************************************************/
    case 5:             /* Modbus code 05 - force a single coil */
#ifdef DEBUG
        printf("\n    ** Request for unimplemented function ** Modbus code 05 - force a single coil");
        printf("\n     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
#if 0
        if (repbuff[4] = 0xFF) {
#ifdef DEBUG
            printf( "     turn coil ON");
#endif
            slave_force_0x();
            }
        else {
#ifdef DEBUG
            printf( "     turn coil OFF");
#endif
            slave_force_0x();
            }
#endif
        break;
/*************************************************************************/
    case 6:             /* Modbus code 06 - preset single register */
#ifdef DEBUG
        printf("\n     Modbus code 06 - preset single register");
        printf("\n     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("\n     data(high): 0x%X   data(low) 0x%X ", repbuff[4], repbuff[5]);
#endif
        slave_preset_4x(cmdbuff, repbuff);
        break;
/*************************************************************************/
    case 7:             /* Modbus code 07 - read slave exception coils */
#ifdef DEBUG
        printf("\n     ** Request for unimplemented function ** Modbus code 07 - read slave exception coils");
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_read_exc_status(); */
        break;
/*************************************************************************/
    case 8:             /* Modbus code 08 - loop back test */
#ifdef DEBUG
        printf("\n     ** Request for unimplemented function ** Modbus code 08 - loop back test");
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_loopback(); */
        break;
/*************************************************************************/
    case 15:            /* Modbus code 15 - force multiple coils */
#ifdef DEBUG
        printf("\n     ** Request for unimplemented function ** Modbus code 15 - force multiple coils");
        printf("\n     address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("\n     quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
        printf("\n     one eighth of quantity ??? : 0x%X", repbuff[6]);
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_force_0x_blk(); */
        break;
/*************************************************************************/
    case 16:            /* Modbus code 16 - preset multiple registers */
#ifdef DEBUG
        printf("\n     Modbus code 16 - preset multiple registers");
        printf("\n   address(high): 0x%X    address(low) 0x%X ", repbuff[2], repbuff[3]);
        printf("\n   quantity(high): 0x%X   quantity(low) 0x%X ", repbuff[4], repbuff[5]);
        printf("\n   twice quantity ??? : 0x%X", repbuff[6]);
#endif
        slave_preset_4x_blk(cmdbuff, repbuff);
        break;
/*************************************************************************/
    case 17:            /* Modbus code 17 - report slave id */
#ifdef DEBUG
        printf("\n     ** Request for unimplemented function ** Modbus code 17 - report slave id");
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
/*      slave_slave_id(); */
        break;
/*************************************************************************/
    default:
#ifdef DEBUG
        printf("\n     Unsupported Modbus Function Type");
#endif
        send_exc_response(1, cmdbuff, repbuff);
                        /* bad function, until implemented */
        break;
        }
#ifdef DEBUG
    printf("");
#endif
    return SUCCESS;
    }                   /* decode_modbus_msg */


short slave_read_0x()
    {                   /* slave_read_0x */
    return SUCCESS;
    }                   /* slave_read_0x */

short slave_read_1x()
    {                   /* slave_read_1x */
    return SUCCESS;
    }                   /* slave_read_1x */

short slave_read_4x(cmdbuff, repbuff, dbuff)
   /* Function to handle request for holding registers */
unsigned char repbuff[], cmdbuff[];
unsigned short dbuff[];
    {                   /* slave_read_4x */
    static short i, j, offset, quantity;

#ifdef DEBUG
    printf("\nIn slave_read_4x");
#endif

/*
 * We Received:        |    We will send:
 * ------------------------------------------------------
 * address             |    address
 * function            |    function
 * data start reg high |    byte count
 * data start reg low  |    data out reg high  40108
 * data # regs high    |    data out reg low   40108
 * data # regs low     |    data out reg high  40109
 *                     |    data out reg low   40109
 *                     |    etc
 */
#ifdef DEBUG  
    printf("\n First 6 response buffer elements, in hex, follow:");
    printf("\n repbuff[0] = %x",repbuff[0]);
    printf("\n repbuff[1] = %x",repbuff[1]);
    printf("\n repbuff[2] = %x",repbuff[2]);
    printf("\n repbuff[3] = %x",repbuff[3]);
    printf("\n repbuff[4] = %x",repbuff[4]);
    printf("\n repbuff[5] = %x",repbuff[5]);
    printf("");
#endif 
    swap((unsigned short *) &repbuff[2], 2);  /* fixup address and quantity */
    offset = repbuff[2];
    quantity = repbuff[4];    /* quantity in 16-bit WORDS, not bytes */

/* alidate quantity here. If greater than 125 registers, send back exception response */
    if (quantity > 125) {
#ifdef DEBUG
	    printf("\n DBG1: QUANTITY = %d",quantity);
	    printf("\n DBG1: OFFSET = %d",offset);
#endif
	    send_exc_response(3, cmdbuff, repbuff);    /* bad data */
	    return FAILURE;
	    }
    
    else {
#ifdef DEBUG
        printf("\nIn slave_read_4x, offset=%X, qty=%X", offset, quantity);
#endif
	if (back_dbread(offset, dbuff, (long)quantity) == 0) {
#ifdef DEBUG
            printf("\nIn slave_read_4x, good status from DBREAD");
#endif
            cmdbuff[0] = repbuff[0];    /* byte 1 is our slave # */
            cmdbuff[1] = repbuff[1];	/* byte 2 is function code */
            cmdbuff[2] = (unsigned char) quantity * 2; /* byte 3 is byte count */

        /* Note: the qty field in the next line was for REGISTERS, so we have to multiply by 2 */
            for (i = 3,  j = 0;  i < (3 + (2 * quantity));  i += 2,  ++j) {
                cmdbuff[i] = (unsigned char) hi(dbuff[j]);
                cmdbuff[i + 1] = (unsigned char) lo(dbuff[j]);
                }
	    slave_wcmd(i, cmdbuff);	/* transmit response */
            return SUCCESS;
            }
        else {
#ifdef DEBUG
            printf("\nIn slave_read_4x, bad status from DBREAD");
#endif
/* Also, transmit back exception response here */
            send_exc_response(2, cmdbuff, repbuff);
                        /* bad address */
            return FAILURE;
            }
        }
    }                   /* slave_read_4x */

short slave_read_3x()
    {                   /* slave_read_3x */
    return SUCCESS;
    }                   /* slave_read_3x */

short slave_force_0x()
    {                   /* slave_force_0x */
    return SUCCESS;
    }                   /* slave_force_0x */

short slave_preset_4x(cmdbuff, repbuff)
   /* Function to handle request for setting a single holding register */
unsigned char repbuff[], cmdbuff[];
    {                   /* slave_preset_4x */
    static short offset;
    static unsigned short data;
    short broadcast;      /* if 1, broadcast mode, send no response */

#ifdef DEBUG
    printf("\nIn slave_preset_4x");
#endif

/*
 * We Received:        |    We will send:
 * ------------------------------------------------------
 * address             |    address
 * function            |    function
 * data reg high       |    data reg high
 * data reg low        |    data reg low 
 * data value high     |    data value hight
 * data value low      |    data value low
 * (In this case response identical to what we received)
 */
    swap((unsigned short *) &repbuff[2], 2);  /* fixup address and data */
    broadcast = !repbuff[0];    /* if broadcast mode, address is 0 */
    offset = *(short *) &repbuff[2];
    data = *(short *) &repbuff[4];

#ifdef DEBUG
    printf("\nIn slave_preset_4x, offset=%X, data=%X", offset, data);
#endif
    if (back_dbwrite(offset, &data, 1) == 0) {
                        /* short offset, unsigned short *buffer, short qty */
#ifdef DEBUG
        printf("\nIn slave_preset_4x, good status from DBWRITE");
#endif
        if (!broadcast) {
                        /* If not Broadcast mode, issue response */
            cmdbuff[0] = repbuff[0];
                        /* byte 1 is our slave # */
            cmdbuff[1] = repbuff[1];
                        /* byte 2 is function code */
            cmdbuff[2] = (unsigned char) hi(offset);
                        /* byte 3 is offset (ho) */
            cmdbuff[3] = (unsigned char) lo(offset);
                        /* byte 4 is offset (lo) */
            cmdbuff[4] = (unsigned char) hi(data);
                        /* byte 5 is data (ho) */
            cmdbuff[5] = (unsigned char) lo(data);
                        /* byte 5 is data (lo) */

            slave_wcmd(6, cmdbuff);
                        /* transmit response if not Broadcast mode */
            }
        return SUCCESS;
        }
    else {
#ifdef DEBUG
        printf("\nIn slave_preset_4x, bad status from DBWRITE");
#endif
/* Also, transmit back exception response here if not Broadcast mode */
        if (!broadcast)
            send_exc_response(2, cmdbuff, repbuff);
                        /* bad address */
        return FAILURE;
        }
    }                   /* slave_preset_4x */

short slave_read_exc_status()
    {                   /* slave_read_exc_status */
    return SUCCESS;
    }                   /* slave_read_exc_status */

short slave_loopback()
    {                   /* slave_loopback */
    return SUCCESS;
    }                   /* slave_loopback */

short slave_force_0x_blk()
    {                   /* slave_force_0x_blk */
    return SUCCESS;
    }                   /* slave_force_0x_blk */

short slave_preset_4x_blk(cmdbuff, repbuff)
   /* Function to handle request for setting a multiple holding registers */
unsigned char repbuff[], cmdbuff[];
    {                   /* slave_preset_4x_blk */
    static short offset, quantity;
    static unsigned char *workptr;
    short broadcast;      /* if 1, broadcast mode, send no response */

/*
 * We Received:        |    We will send:
 * ------------------------------------------------------
 * address             |    address
 * function            |    function
 * reg addr high       |    reg addr high
 * reg addr low        |    reg addr low 
 * data quantity high  |    data quantity high
 * data quantity low   |    data quantity low
 * byte count          |
 * data high    reg 1  |
 * data low            |
 * data high    reg 2  |
 * data low            |
 */
    swap((unsigned short *) &repbuff[2], 2);  /* fixup address and quantity */
    offset = *(short *) &repbuff[2];
    broadcast = !repbuff[0];          /* If broadcast mode, address is 0 */
    quantity = *(short *) &repbuff[4]; /* quantity in 16-bit WORDS, not bytes */
#ifdef DEBUG
	    printf("\nIn slave_preset_4x_blk, offset=%X, quantity=%X", offset, quantity);
#endif

/*
 * Validate quantity here.
 * If greater than 125 registers,
 * and not broadcast mode,
 * send back exception response
 */
    if ((quantity > 125) && (!broadcast)) {
        send_exc_response(3, cmdbuff, repbuff);
                        /* bad data */
        return FAILURE;
        }
    else
    {
        workptr = (unsigned char *) &repbuff[0];
        workptr += 7;   /* skip addr/func/haddr/laddr/hqty/lqty/bytecount */

        swap((unsigned short *) workptr, quantity);
            /* swap database databytes */

        if (back_dbwrite(offset, (unsigned short *) workptr, quantity) == 0) {
                        /* short offset, unsigned short *buffer, short quantity */

#ifdef DEBUG
            printf("\nIn slave_preset_4x_blk, good status from DBWRITE");
#endif
            if (!broadcast) {
                        /* If not Broadcast mode, issue response */
                cmdbuff[0] = repbuff[0];
                        /* byte 1 is our slave # */
                cmdbuff[1] = repbuff[1];
                        /* byte 2 is function code */
                cmdbuff[2] = (unsigned char) hi(offset);
                        /* byte 3 is offset (ho)*/
                cmdbuff[3] = (unsigned char) lo(offset);
                        /* byte 4 is offset (lo) */
                cmdbuff[4] = (unsigned char) hi(quantity);
                        /* byte 5 is quantity (ho) */
                cmdbuff[5] = (unsigned char) lo(quantity);
                        /* byte 6 is quantity (lo) */

                slave_wcmd(6, cmdbuff);
                        /* transmit response */
                }
            return SUCCESS;
            }
        else {
#ifdef DEBUG
            printf("\nIn slave_preset_4x_blk, bad status from DBWRITE");
#endif
/* Also, transmit back exception response here */
            if (!broadcast) /* If not Broadcast mode, issue response */
                send_exc_response(2, cmdbuff, repbuff);
                        /* bad address */
            return FAILURE;
            }
        }
    }                   /* slave_preset_4x_blk */


short slave_slave_id()
    {                   /* slave_slave_id */
    return SUCCESS;
    }                   /* slave_slave_id */

static short swap(T, qty)
unsigned short T[];
short qty;
    {                   /* swap */
    short i;
    unsigned short cswap;

    for (i = 0;  i < qty;  ) {
        cswap = T[i];
        cswap >>= 8;
        T[i] <<= 8;
        T[i++] |= cswap;
        }
    return SUCCESS;
    }                   /* swap */

short send_exc_response(code, cmdbuff, repbuff)
   /* Send exception response */
short code;               /* Error  code */
/*
 * Error Codes:
 * 1     Illegal Function
 * 2     Illegal Data Address
 * 3     Illegal Data Value
 * 4     Failure in associated device
 * 5     Acknowledge
 * 6     Busy, rejected message
 * 7     Nak-Negative acknowledgement
 */
unsigned char repbuff[], cmdbuff[];
    {                   /* send_exc_response */
    cmdbuff[0] = (unsigned char) repbuff[0];
                        /* byte 1 is our slave # */
    cmdbuff[1] = (unsigned char) repbuff[1] | 0x80;
                        /* byte 2 is function code plus exception bit */
    cmdbuff[2] = (unsigned char) code;  /* Error code */
    slave_wcmd(3, cmdbuff);
                        /* transmit response */
    return SUCCESS;
    }                   /* send_exc_response */

/******************* End of fslave.c **************************/

/*
This module contains the following functions:
back_dbread()
back_dbwrite()

*/

/*
global definitions

*/
#define RETURN_GOOD_STATUS  0           /*library call success*/
#define RETURN_BAD_STATUS   -1          /*library call error*/


/*
procedure back_dbwrite()

This procedure writes to the database structure which is contained in
the C996 memory.

back_dbwrite()
{
    if( offset + quantity is not within boundary of database )
        return( error );
    move data from buffer into database;
    return( good status );

}
*/

short back_dbwrite(offset, buffer, quantity)
short offset;
unsigned short *buffer;
short quantity;
    {
    long db_size;       /*size of database in words*/

    if (quantity > 255)
        return (RETURN_BAD_STATUS); /*return error*/

    db_size = (sizeof (this_database) / 2L);
                        /*get size in words (8 words/paragraph)*/

    if (((long) offset + (long) quantity) > db_size)
        return (RETURN_BAD_STATUS); /*not entirely within boundaries of database*/

    memmove((unsigned char *) this_database + (offset * 2), buffer, quantity * 2);

    return (RETURN_GOOD_STATUS);    /*return good status*/
    }

/*
procedure back_dbread()

This procedure reads from the database structure which is contained in
the C996 memory.

back_dbread()
{
    if( offset + quantity is not within boundary of database )
        return( error );
    move data from database into buffer;
    return( good status );

}
*/

short back_dbread(offset, buffer, quantity)
long offset;
unsigned short *buffer;
long quantity;
    {
    long db_size;       /*size of database in words*/

    if (quantity > 255){
#ifdef DEBUG
	    printf("\n DBG4: Quantity = %d",quantity);
#endif
	    return (RETURN_BAD_STATUS); /*return error*/
    }

    db_size = (sizeof (this_database) * 2L);
                        /*get size in words (8 words/paragraph)*/

    if (((long) offset + (long) quantity) > db_size){
#ifdef DEBUG
	    printf("\n DBG2: offset   = 0x%x",offset);
    	    printf("\n DBG2: quantity = 0x%x",quantity);
    	    printf("\n DBG2: db_size   = 0x%x",db_size);
#endif
            return (RETURN_BAD_STATUS); /*not entirely within boundaries of database*/
    }

    memmove(buffer, (unsigned char *) this_database + (offset * 2), quantity * 2);

    return (RETURN_GOOD_STATUS);    /*return good status*/
    }


/*************************************************************************
* slave_wcmd  write given sequence of command bytes to slave network, and append
*       appropriate type of checksum (LRC or CRC) to the message end.
*************************************************************************/

short slave_wcmd(nbytes, cmdbuff)
short nbytes;             /* number of bytes to write     */
unsigned char cmdbuff[];    /* buffer of bytes to send      */
    {


    if (ncb_send(data_ncbp, nbytes, cmdbuff, 30) != 0) {
                        /*send the command*/
#ifdef DEBUG
	    printf("\nSend error: %d.", data_ncbp->NCB_RETCODE);
#endif
/*          ncb_close(data_ncbp);   close the path*/
        return data_ncbp->NCB_RETCODE;   /* "failure in associated device" */
        }
    else 
        return 0;
    }

/*************************************************************************
* slave_rrep  read slave reply 
*************************************************************************/

short slave_rrep(n_bytes, repbuff)
short *n_bytes;           /* # of data bytes (ex chksum) read by rrep */
unsigned char repbuff[];    /* buffer to store the reply    */
/************************************************************************/
    {

    *n_bytes = 0;       /* initially set n_bytes to 0 */

    if (ncb_receive_wait(data_ncbp, repbuff, 4) != 0) { 
                        /*try to receive*/
#ifdef DEBUG
	    printf("Receive error: %d.", data_ncbp->NCB_RETCODE);
#endif	    
/*          ncb_close(nd);  close the path*/
        *n_bytes = 0;
	return data_ncbp->NCB_RETCODE;   /* "failure in associated device" */
    } 
    else{
        *n_bytes = data_ncbp->NCB_LENGTH;
        return 0;
        }
    }

/*************************************************************************
* hi    returns high order byte (in low order bits) of argument
*************************************************************************/

short hi(arg)
unsigned short arg;
    {
    return ((arg & 0xFF00) >> 8);
    }

/*************************************************************************
* lo    returns low order byte (in low order bits) of argument
*************************************************************************/

short lo(arg)
unsigned short arg;
    {
    return (arg & 0xFF);
    }

/*********************** end of testslav.c ************************/
